/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, Point_$type, runOn, fromEnum, markType, PointUtil } from "igniteui-react-core";
import { ISeriesViewerInteractionManager_$type } from "./ISeriesViewerInteractionManager";
import { SeriesHighlightingManager } from "./SeriesHighlightingManager";
import { SeriesViewerScrollbarManager } from "./SeriesViewerScrollbarManager";
import { Rect } from "igniteui-react-core";
import { TileZoomManager } from "./TileZoomManager";
import { Size } from "igniteui-react-core";
import { MathUtil } from "igniteui-react-core";
import { MouseEventArgs } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var SeriesViewerInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerInteractionManager, _super);
    function SeriesViewerInteractionManager() {
        var _this = _super.call(this) || this;
        _this.t = 0;
        _this.u = 0;
        _this.ai = null;
        _this.q = 0;
        _this.r = 0;
        _this.p = 0;
        _this.s = 0;
        _this.i = false;
        _this.aj = null;
        _this.al = null;
        _this.j = false;
        _this.l = false;
        _this.f = null;
        _this.d = null;
        _this.e = null;
        _this.ak = null;
        _this.am = null;
        _this.c = null;
        _this.a = null;
        _this.h = false;
        _this.ak = Rect.empty;
        _this.aj = Rect.empty;
        return _this;
    }
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "f$d", {
        get: function () {
            if (this.d == null) {
                this.d = new SeriesHighlightingManager();
            }
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "f$b", {
        get: function () {
            if (this.e == null) {
                this.e = new SeriesViewerScrollbarManager();
            }
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    SeriesViewerInteractionManager.prototype.f$ao = function (a, b) {
        var c = null;
        var d = null;
        var e = null;
        e = a.cu.e();
        var f;
        var g = ((function () { var h = a.cu.f(b, false, f, false); f = h.p2; return h.ret; })());
        if (g != e) {
            if (e != null && e.a3.a$c) {
                e.a3.a$z(e, b, null, null, false);
            }
        }
        c = f;
        if (a != null) {
            a.ph(b);
        }
        if (g != null && !g.a3.a$c) {
            g.a3.a$y(g, b, c, d, false);
        }
    };
    SeriesViewerInteractionManager.prototype.f$a = function (a) {
        if (a.av != 0) {
            return a.av;
        }
        var b = 1;
        var c = false;
        var d = false;
        for (var e = 0; e < a.series.count; e++) {
            var f = a.series._inner[e];
            if (f.isStacked) {
                f.n6(function (g) {
                    if (g.bt == 2) {
                        c = true;
                    }
                    if (g.bt == 1) {
                        d = true;
                    }
                    return true;
                });
            }
            else {
                if (f.bt == 2) {
                    c = true;
                }
                if (f.bt == 1) {
                    d = true;
                }
            }
        }
        if (d) {
            b = 1;
        }
        if (c) {
            b = 2;
        }
        if (c && d) {
            b = 3;
        }
        return b;
    };
    SeriesViewerInteractionManager.prototype.f$an = function (a) {
        var b = a.ti;
        var c = b;
        var d = a.cu;
        var e = a.du();
        var f = a.dx;
        var g = a.e8;
        var h = a.fh;
        if (!e) {
            c = { $type: Point_$type, x: NaN, y: NaN };
        }
        if (c.x < 0 || c.x > 1 || c.y < 0 || c.y > 1) {
            c = { $type: Point_$type, x: NaN, y: NaN };
        }
        for (var i = 0; i < a.series.count; i++) {
            var j = a.series._inner[i];
            j.oe(c);
        }
        a.mo(c);
        var k = a.cl == 0 && !a.ef && (a.d3 || f) && !g && !h;
        var l = a.t6;
        if (k && !isNaN_(b.x) && !l.isEmpty) {
            var m = l.width * (b.x - a.tr.left) / a.tr.width;
            d.eo(l.left + m, l.top, l.left + m, l.bottom);
            d.ed();
            d.ei(m);
        }
        else {
            d.cl();
        }
        if (k && !isNaN_(b.y) && !l.isEmpty) {
            var n = l.height * (b.y - a.tr.top) / a.tr.height;
            d.eh(l.left, l.top + n, l.right, l.top + n);
            d.d9();
        }
        else {
            d.cg();
        }
    };
    SeriesViewerInteractionManager.prototype.f$ag = function (a) {
        switch (a.cl) {
            case 0:
                a.cu.d5();
                this.f$an(a);
                a.cu.cd();
                break;
            case 1:
                a.cu.d7();
                a.cu.ck();
                this.f$an(a);
                a.cu.cc();
                break;
            case 2:
                a.cu.d7();
                a.cu.ck();
                this.f$an(a);
                a.cu.ce();
                break;
        }
    };
    SeriesViewerInteractionManager.prototype.f$q = function (a, b) {
        if (b.x >= 0 && b.y >= 0 && b.x <= a.t6.width && b.y <= a.t6.height) {
            this.ae(a, b);
        }
        else {
            a.ma();
        }
    };
    SeriesViewerInteractionManager.prototype.ae = function (a, b) {
        var e_1, _a;
        var c = a.cu;
        var d = a.t6;
        if (a.eg || a.ef) {
            return;
        }
        if (a.dx && a.d3) {
            var e = d.height > d.width;
            c.bv(e);
            try {
                for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (f.isStacked) {
                        f.n6(function (g) {
                            if (g._visibility == 0) {
                                g.p3(b, runOn(c, c.bm));
                            }
                            if (g.dw) {
                                g.n4(function (h) {
                                    if (h._visibility == 0) {
                                        h.p3(b, runOn(c, c.bm));
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    else if (f.dw) {
                        if (f._visibility == 0) {
                            if (f._visibility == 0) {
                                f.p3(b, runOn(c, c.bm));
                            }
                        }
                        f.n4(function (g) {
                            if (g._visibility == 0) {
                                g.p3(b, runOn(c, c.bm));
                            }
                            return true;
                        });
                    }
                    else {
                        if (f._visibility == 0) {
                            f.p3(b, runOn(c, c.bm));
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            c.ea();
        }
    };
    SeriesViewerInteractionManager.prototype.ad = function (a, b) {
        if (a.d3 || a.ed) {
            a.dx = true;
            a.oc();
            this.aj = new Rect(0, b.x, b.y, 0, 0);
            this.al = new Rect(0, b.x, b.y, 0, 0);
            a.cl = 0;
            a.l1(a.tl(b));
        }
    };
    SeriesViewerInteractionManager.prototype.f$ae = function (a, b) {
        this.ad(a, b);
        this.ae(a, b);
        this.f$an(a);
    };
    SeriesViewerInteractionManager.prototype.f$r = function (a, b, c) {
        if (!a.dx) {
            this.ag(a, b, c);
        }
    };
    SeriesViewerInteractionManager.prototype.f$p = function (a, b) {
        this.ak = Rect.empty;
        a.ma();
    };
    SeriesViewerInteractionManager.prototype.f$al = function (a) {
        if (this.j) {
            this.f$b.onScrollbarDragCancel();
            this.j = false;
        }
        var b = a.cu;
        this.s = 1;
        this.ac(a);
        a.cl = 0;
        this.i = true;
        a.e8 = true;
        a.od();
    };
    SeriesViewerInteractionManager.prototype.ac = function (a) {
        var b = a.cu;
        a.dx = false;
        b.cj();
        b.cf();
        b.ch();
        a.l1({ $type: Point_$type, x: NaN, y: NaN });
        b.cg();
        b.cl();
        b.ck();
    };
    SeriesViewerInteractionManager.prototype.f$ad = function (a, b) {
        this.f$al(a);
    };
    SeriesViewerInteractionManager.prototype.f$am = function (a, b, c, d, e) {
        this.t = b.x;
        this.u = b.y;
        this.q = c;
        this.r = d;
        this.p = e;
        this.ai = a.tr;
        this.f$al(a);
    };
    SeriesViewerInteractionManager.prototype.f$ac = function (a, b) {
        var c = a.cu;
        c.cg();
        c.cl();
        if (c.av) {
            this.y(a, b);
        }
        else {
            this.aa(a, b);
            this.s = b;
        }
    };
    SeriesViewerInteractionManager.prototype.f$ai = function (a, b, c, d, e) {
        var f = a.cu;
        f.cg();
        f.cl();
        this.q = this.q * c;
        this.r = this.r * d;
        this.p = this.p * e;
        if (a.em) {
            this.q = this.p;
            this.r = this.p;
        }
        var g = a.tr;
        var h = a.t6;
        var i = b.x - this.t;
        var j = b.y - this.u;
        this.t = b.x;
        this.u = b.y;
        var k = g.width;
        var l = g.height;
        var m = this.ai.width / this.q;
        var n = this.ai.height / this.r;
        if (m > 1) {
            m = 1;
        }
        if (n > 1) {
            n = 1;
        }
        var o = { $type: Point_$type, x: b.x, y: b.y };
        var p = { $type: Point_$type, x: (o.x - h.left) / h.width * g.width + g.left, y: (o.y - h.top) / h.height * g.height + g.top };
        var q = new Rect(0, g.left, g.top, m, n);
        var r = { $type: Point_$type, x: (p.x - q.left) / q.width * h.width + h.left, y: (p.y - q.top) / q.height * h.height + h.top };
        var s = (r.x - o.x) - i;
        var t = (r.y - o.y) - j;
        var u = s / h.width * q.width;
        var v = t / h.height * q.height;
        q = new Rect(0, q.left + u, q.top + v, q.width, q.height);
        g = q;
        a.py(g, true);
    };
    SeriesViewerInteractionManager.prototype.f$z = function (a, b) {
        this.aj = new Rect(0, b.x, b.y, 0, 0);
        this.al = new Rect(0, b.x, b.y, 0, 0);
    };
    SeriesViewerInteractionManager.prototype.z = function (a, b, c) {
        var d = a.tr.width;
        var e = a.tr.height;
        var f = a.tr.left + d / 2;
        var g = a.tr.top + e / 2;
        d = d / b;
        e = e / b;
        var h = f - d / 2;
        var i = g - e / 2;
        a.py(new Rect(0, h, i, d, e), true);
    };
    SeriesViewerInteractionManager.prototype.f$ab = function (a, b) {
        var c = a.cu;
        if (c.av) {
            this.y(a, b);
        }
        else {
            this.aa(a, b);
        }
        this.aj = Rect.empty;
        a.e8 = false;
    };
    SeriesViewerInteractionManager.prototype.f$s = function (a, b) {
        a.e8 = false;
        this.aj = Rect.empty;
        a.ma();
    };
    SeriesViewerInteractionManager.prototype.f$y = function (a, b) {
        a.lu();
    };
    SeriesViewerInteractionManager.prototype.f$ah = function (a, b, c, d, e) {
        a.e8 = false;
        this.aj = Rect.empty;
        a.ma();
    };
    SeriesViewerInteractionManager.prototype.y = function (a, b) {
        var c = a.t7;
        var d = 1 / b;
        var e = { $type: Point_$type, x: c.x + c.width / 2, y: c.y + c.height / 2 };
        var f = { $type: Point_$type, x: c.x - e.x, y: c.y - e.y };
        var g = new Rect(0, f.x * d + e.x, f.y * d + e.y, c.width * d, c.height * d);
        a.py(g, true);
    };
    SeriesViewerInteractionManager.prototype.aa = function (a, b) {
        var c = a.t6;
        var d = a.t7;
        var e = b - this.s;
        if (e != 0) {
            var f = 0.03;
            var g = e < 0 ? 1 + f : 1 - f;
            var h = { $type: Point_$type, x: d.x + d.width / 2, y: d.y + d.height / 2 };
            var i = { $type: Point_$type, x: d.x - h.x, y: d.y - h.y };
            var j = new Rect(0, i.x * g + h.x, i.y * g + h.y, d.width * g, d.height * g);
            a.py(j, true);
        }
    };
    SeriesViewerInteractionManager.prototype.f$n = function (a, b, c) {
        if (!a.e8) {
            this.i = false;
        }
        var d = false;
        if (a.dy) {
            if (this.f$b.shouldHandleInteraction(b, c)) {
                this.j = true;
                d = true;
                this.ac(a);
                a.cu.dr();
                return;
            }
        }
        this.ag(a, b, c);
        a.nt(b, c);
    };
    SeriesViewerInteractionManager.prototype.ag = function (a, b, c) {
        var d;
        var e = a.cu;
        var f = a.cj(c);
        if (e.ez == 0) {
            switch (f) {
                case 1:
                    d = a.eu() ? f : 0;
                    break;
                default:
                    d = f;
                    break;
            }
        }
        else {
            if (e.ez == a.sr) {
                d = 1;
            }
            else if (e.ez == a.ss) {
                d = 2;
            }
            else {
                d = 0;
            }
        }
        switch (d) {
            case 1:
            case 2:
                a.cu.ca();
                a.cu.dr();
                break;
        }
        a.cl = d;
        switch (a.cl) {
            case 1:
                a.l1({ $type: Point_$type, x: NaN, y: NaN });
                this.aj = new Rect(0, b.x, b.y, 0, 0);
                this.al = new Rect(0, b.x, b.y, 0, 0);
                this.ak = new Rect(0, b.x, b.y, 0, 0);
                e.d8();
                e.eg(this.aj);
                a.oi(Rect.empty, true);
                break;
            case 2:
                this.aj = new Rect(0, b.x, b.y, 0, 0);
                this.ak = new Rect(0, b.x, b.y, 0, 0);
                break;
        }
        this.am = a.tr;
        a.t8 = a.tr;
    };
    SeriesViewerInteractionManager.prototype.f$ak = function (a) {
        a.pi();
        a.cu.dl();
    };
    SeriesViewerInteractionManager.prototype.f$aj = function (a) {
        a.l5();
        a.cu.dk();
    };
    SeriesViewerInteractionManager.prototype.f$ap = function (a) {
        if (a.dt && !this.l) {
            this.l = true;
            this.af(a);
        }
    };
    SeriesViewerInteractionManager.prototype.f$k = function (a) {
        if (this.l) {
            this.ab(a);
            this.l = false;
        }
    };
    SeriesViewerInteractionManager.prototype.f$h = function (a) {
        if (this.f == null) {
            return;
        }
        this.g.ab();
    };
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    SeriesViewerInteractionManager.prototype.af = function (a) {
        if (this.f == null) {
            this.f = new TileZoomManager(a, true, a.hy);
            this.f.h = !a.e9;
        }
        a.ec = true;
        a.oh();
        this.f.al();
        a.cu.br();
        a.cu.bs();
    };
    SeriesViewerInteractionManager.prototype.ab = function (a) {
        if (this.f == null) {
            return;
        }
        a.ec = false;
        a.cu.dg();
        this.f.ah();
        a.o2();
        a.cu.by();
    };
    SeriesViewerInteractionManager.prototype.f$j = function (a) {
        a.lz();
        a.o4();
    };
    SeriesViewerInteractionManager.prototype.n = function (a) {
        return a.cl == 2;
    };
    SeriesViewerInteractionManager.prototype.o = function (a, b) {
        return a.cb == 1 || b || a.dt;
    };
    SeriesViewerInteractionManager.prototype.m = function (a) {
        return a.cl == 1;
    };
    SeriesViewerInteractionManager.prototype.f$m = function (a, b, c) {
        var d = a.cu;
        if (this.j) {
            a.a9.onScrollbarDrag(b, c);
            return;
        }
        if (this.aj.isEmpty && c) {
            this.ag(a, b, c);
        }
        var e = 2;
        if (c) {
            e = 10;
        }
        var f = false;
        var g = new Rect(2, { $type: Point_$type, x: this.aj.x, y: this.aj.y }, b);
        var h = new Rect(0, 0, 0, 0, 0);
        if (!this.ak.isEmpty) {
            h = new Rect(2, { $type: Point_$type, x: this.ak.x, y: this.ak.y }, b);
        }
        if (h.width > e && h.height > e) {
            f = true;
        }
        if (!a.e8) {
            if (f) {
                this.i = false;
            }
        }
        if (!a.e8 && (a.dx || !c)) {
            a.l1(a.tl(b));
        }
        if (this.m(a)) {
            if (f) {
                var i = a.t5(g);
                a.oi(i, true);
            }
            else {
                a.oi(Rect.empty, true);
            }
            a.m1();
            d.eg(g);
        }
        var j = a.t6;
        var k = a.tr;
        if (this.n(a)) {
            var l = j;
            var m = k.left + k.width * (this.aj.x - b.x) / l.width;
            var n = k.top + k.height * (this.aj.y - b.y) / l.height;
            var o = new Rect(0, m, n, k.width, k.height);
            if (this.o(a, c)) {
                if (h.width != 0 || h.height != 0) {
                    a.od();
                }
                a.oi(Rect.empty, true);
                var p = a.tr;
                a.py(o, true);
                var q = a.tr;
                if (p.equals1(q) && a.cu.k.ac) {
                    a.cu.k.au();
                }
                this.aj = new Rect(3, b, new Size(1, 0, 0));
                this.al = new Rect(3, b, new Size(1, 0, 0));
            }
            else {
                a.oi(o, true);
            }
        }
        this.al = new Rect(3, b, new Size(1, 0, 0));
        d.bu(b);
    };
    SeriesViewerInteractionManager.prototype.f$l = function (a, b, c, d) {
        var e = a.cu;
        var f = 2;
        if (c) {
            f = 10;
        }
        var g = a.t6;
        var h = a.tr;
        if (!d) {
            if (this.j) {
                this.f$b.onScrollbarDragComplete(b, c);
                this.j = false;
                e.bw();
                return;
            }
        }
        if (!this.i) {
            var i = false;
            var j = new Rect(2, { $type: Point_$type, x: this.aj.x, y: this.aj.y }, b);
            if (j.width > f && j.height > f) {
                i = true;
            }
            if (a.cl == 1) {
                a.m0();
                e.cf();
                if (i) {
                    a.py(a.t5(j), true);
                }
            }
            if (a.cl == 2) {
                var k = g;
                var l = h.left + h.width * (this.aj.x - b.x) / k.width;
                var m = h.top + h.height * (this.aj.y - b.y) / k.height;
                a.py(new Rect(0, l, m, h.width, h.height), true);
            }
        }
        var n = false;
        var o = new Rect(2, { $type: Point_$type, x: this.ak.x, y: this.ak.y }, b);
        if (o.width > f || o.height > f) {
            n = true;
        }
        if (n) {
            a.fh = true;
        }
        a.cl = 0;
        a.oi(Rect.empty, true);
        e.bw();
        a.fh = false;
        e.cg();
        e.cl();
        if (c) {
            e.ck();
            e.cg();
            e.cl();
            e.ch();
        }
        a.ma();
        a.oc();
        a.nu(b, c, d);
    };
    SeriesViewerInteractionManager.prototype.f$af = function (a) {
        if (this.g != null) {
            this.g.h = !a.e9;
        }
    };
    SeriesViewerInteractionManager.prototype.f$e = function (a, b) {
        var c = a.cu;
        var d = a.tr;
        if (a.cl == 2 && b == 8) {
            c.bt();
            a.cl = 0;
            a.oc();
            a.oi(Rect.empty, true);
            if (a.cb == 1) {
                a.py(this.am, true);
            }
            return true;
        }
        if (a.cl == 1 && b == 8) {
            c.bt();
            a.cl = 0;
            a.oc();
            c.cf();
            a.oi(Rect.empty, true);
            return true;
        }
        var e = Rect.empty;
        var f = false;
        switch (b) {
            case 13:
                f = true;
                e = new Rect(0, 0, 0, 1, 1);
                break;
            case 11:
                f = true;
                e = new Rect(0, d.left - 0.1 * d.width, d.top - 0.1 * d.height, 1.2 * d.width, 1.2 * d.height);
                break;
            case 10:
                f = true;
                e = new Rect(0, d.left + 0.1 * d.width, d.top + 0.1 * d.height, 0.8 * d.width, 0.8 * d.height);
                break;
            case 14:
                f = true;
                e = new Rect(0, d.left - 0.1 * d.width, d.top, d.width, d.height);
                e.x = e.x - Math.min(e.left, 0);
                break;
            case 16:
                f = true;
                e = new Rect(0, d.left + 0.1 * d.width, d.top, d.width, d.height);
                e.x = e.x - Math.max(e.right - 1, 0);
                break;
            case 15:
                f = true;
                e = new Rect(0, d.left, d.top - 0.1 * d.height, d.width, d.height);
                e.y = e.y - Math.min(e.top, 0);
                break;
            case 17:
                f = true;
                e = new Rect(0, d.left, d.top + 0.1 * d.height, d.width, d.height);
                e.y = e.y - Math.max(e.bottom - 1, 0);
                break;
        }
        if (!e.isEmpty && Rect.l_op_Inequality(e, d)) {
            a.py(e, true);
        }
        return f;
    };
    SeriesViewerInteractionManager.prototype.f$f = function (a, b, c) {
        var d = a.cu;
        var e = a.tr;
        var f = e.left + e.width * b.x / a.t6.width;
        var g = e.top + e.height * b.y / a.t6.height;
        var h = 1 - MathUtil.d(c, -0.5, 0.5);
        var i = Math.max(0, f - h * (f - e.left));
        var j = Math.min(1, g + h * (e.bottom - g));
        var k = Math.min(1, f + h * (e.right - f));
        var l = Math.max(0, g - h * (g - e.top));
        a.od();
        this.x(a, 1000);
        a.py(new Rect(0, i, l, k - i, j - l), true);
        return a.eu();
    };
    SeriesViewerInteractionManager.prototype.x = function (a, b) {
        a.cu.bz(b);
    };
    SeriesViewerInteractionManager.prototype.f$o = function (a, b) {
        var c = a.tr;
        var d = c.left + c.width * b.x / a.t6.width;
        var e = c.top + c.height * b.y / a.t6.height;
        var f = 0.7;
        var g = Math.max(0, d - f * (d - c.left));
        var h = Math.min(1, e + f * (c.bottom - e));
        var i = Math.min(1, d + f * (c.right - d));
        var j = Math.max(0, e - f * (e - c.top));
        a.py(new Rect(0, g, j, i - g, h - j), true);
    };
    SeriesViewerInteractionManager.prototype.f$i = function (a) {
        this.g.ac();
    };
    SeriesViewerInteractionManager.prototype.f$c = function (a, b, c, d, e, f, g) {
        var e_2, _a;
        var h = true;
        var i = false;
        var j = false;
        var k = a;
        if (k.au == 1) {
            h = false;
            i = true;
        }
        if (k.au == 3 || k.au == 4) {
            i = true;
        }
        if (k.au == 4) {
            j = true;
        }
        var l = truncate(Math.round(d.x));
        var m = truncate(Math.round(d.y));
        f = null;
        var n = -1;
        if (h && c != null) {
            var o = l;
            var p = m;
            if (a.gi != 1) {
                o = truncate(Math.round(d.x * a.gi));
                p = truncate(Math.round(d.y * a.gi));
            }
            var q = c.a(o, p);
            if (q == null || q.length == 0) {
                f = null;
                return {
                    ret: null,
                    p5: f
                };
            }
            if ((q[0] > 0 || q[1] > 0 || q[2] > 0) && q[3] == 255) {
                var num2_ = q[2];
                if (num2_ % 4 != 0) {
                    num2_ = num2_ + (4 - (num2_ % 4));
                }
                var num1_ = q[1];
                if (num1_ % 4 != 0) {
                    num1_ = num1_ + (4 - (num1_ % 4));
                }
                var num0_ = q[0];
                if (num0_ % 4 != 0) {
                    num0_ = num0_ + (4 - (num0_ % 4));
                }
                var num_ = 0;
                num_ = (num2_ >> 2);
                num_ = (num_ << 6);
                num_ = (num_ | (num1_ >> 2));
                num_ = (num_ << 6);
                num_ = (num_ | (num0_ >> 2));
                n = truncate(Math.floor((intDivide(num_, 1000))));
                n--;
            }
        }
        var r = null;
        var s = -1;
        if (n >= 0) {
            var t_1 = false;
            var u_1 = 0;
            try {
                for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var v = _c.value;
                    if (!v.fl) {
                        continue;
                    }
                    if (t_1) {
                        break;
                    }
                    if (v.isStacked) {
                        v.n6(function (w) {
                            if (w.jm == n) {
                                r = w;
                                s = u_1;
                                t_1 = true;
                                return false;
                            }
                            return true;
                        });
                    }
                    else if (v.jm == n) {
                        r = v;
                        s = u_1;
                        break;
                    }
                    u_1++;
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var w = null;
        if (i) {
            var x = false;
            for (var y = b.count - 1; y >= 0; y--) {
                var z = b._inner[y];
                if (!z.fl) {
                    continue;
                }
                var aa = z.cg;
                if (!z.gm(aa.bx, aa.by, aa)) {
                    continue;
                }
                if (!x && y < s && h && !j) {
                    if (r != null) {
                        w = r;
                        x = true;
                        break;
                    }
                }
                if (z != null && z.bt == 1) {
                    if (z.f5(d, g)) {
                        w = z;
                        break;
                    }
                }
            }
            if (h && !x) {
                if (r != null) {
                    w = r;
                    x = true;
                }
            }
        }
        else {
            w = r;
        }
        if (w != null) {
            var ab = w.au({ $type: Point_$type, x: l, y: m }, g);
            if (ab != null) {
                f = ab;
            }
            return {
                ret: w,
                p5: f
            };
        }
        return {
            ret: null,
            p5: f
        };
    };
    SeriesViewerInteractionManager.prototype.f$g = function (a, b) {
        if (PointUtil.equals(b, null)) {
            return false;
        }
        var c = b.x;
        var d = b.y;
        if (this.j) {
            return true;
        }
        if (c >= a.t6.left && d >= a.t6.top && c <= a.t6.left + a.t6.width && d <= a.t6.top + a.t6.height) {
            var e = a.cn;
            if (e != null && e.viewShouldInteract(b)) {
                return false;
            }
            return true;
        }
        return false;
    };
    SeriesViewerInteractionManager.prototype.b = function (a) {
        if (a != null) {
            return a.bh();
        }
        else {
            return null;
        }
    };
    SeriesViewerInteractionManager.prototype.f$w = function (a, b, c, d, e, f) {
        var _this = this;
        if (!f && a.ds) {
            this.ah(a, false);
        }
        var g = new MouseEventArgs();
        g.position = d;
        if (a.cl == 2 || a.cl == 1 || a.e8 || (a.cn != null && a.cn.isPinching)) {
            if (this.c != null) {
                this.c.a3.a$z(this.c, g.position, this.a, g, f);
                this.c = null;
            }
            return;
        }
        var h = null;
        var i = ((function () { var j = _this.f$c(a, b, c, d, !e, h, f); h = j.p5; return j.ret; })());
        this.a = h;
        var j = this.b(i);
        if (i != null) {
            var k = false;
            var l = false;
            if (this.c != i) {
                l = true;
            }
            if (this.c == null || l) {
                k = true;
            }
            if (k) {
                if (l) {
                    if (this.c != null) {
                        j = this.b(this.c);
                        this.c.a3.a$z(this.c, g.position, h, g, f);
                        if (j != null) {
                            j.a3.a$z(j, g.position, h, g, f);
                        }
                    }
                }
                this.c = i;
                i.ov(g.position, h, g, f);
                if (j != null) {
                    j.ov(g.position, h, g, f);
                }
            }
            else {
                this.c = i;
                i.a3.a$ab(i, g.position, h, g, f);
                if (j != null) {
                    j.a3.a$ab(j, g.position, h, g, f);
                }
            }
        }
        else {
            if (this.c != null) {
                j = this.b(this.c);
                this.c.a3.a$z(this.c, g.position, h, g, f);
                if (j != null) {
                    j.a3.a$z(j, g.position, h, g, f);
                }
                this.c = null;
            }
            for (var m = 0; m < a.series.count; m++) {
                var n = a.series._inner[m];
                if (n.a3.a$b) {
                    j = this.b(n);
                    n.a3.a$z(n, g.position, n.a3.a$p, g, f);
                    if (j != null) {
                        j.a3.a$z(j, g.position, n.a3.a$p, g, f);
                    }
                }
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$v = function (a, b) {
        if (this.c != null) {
            var c = this.b(this.c);
            var d = new MouseEventArgs();
            d.position = b;
            this.c.a3.a$z(this.c, d.position, null, d, false);
            if (c != null) {
                c.a3.a$z(c, d.position, null, d, false);
            }
            this.c = null;
        }
        a.no(b, a.cl != 0 || a.ez);
    };
    SeriesViewerInteractionManager.prototype.f$u = function (a, b, c) {
        if (this.c != null) {
            var d = new MouseButtonEventArgs();
            d.position = c;
            if (b.al) {
                this.c.a3.a$ac(this.c, d.position, this.a, d);
            }
            else {
                this.c.a3.a$w(this.c, d.position, this.a, d);
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$x = function (a, b, c) {
        var d;
        var e = (this.c != null) ? this.c : ((function () { var f = a.cu.f(c, false, d, false); d = f.p2; return f.ret; })());
        if (e != null) {
            var f = new MouseButtonEventArgs();
            f.position = c;
            if (b.al) {
                e.a3.a$ad(e, f.position, this.a, f);
            }
            else {
                e.a3.a$aa(e, f.position, this.a, f);
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$t = function (a, b, c) {
        if (!c && a.e1) {
            this.ah(a, false);
        }
        if (c && !a.e1) {
            this.ah(a, true);
        }
        a.m5(b, c);
    };
    SeriesViewerInteractionManager.prototype.ah = function (a, b) {
        if (a != null) {
            if (!this.k) {
                a.ds = b;
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$aa = function (a, b) {
        this.h = true;
    };
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "k", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    SeriesViewerInteractionManager.$t = markType(SeriesViewerInteractionManager, 'SeriesViewerInteractionManager', Base.$, [ISeriesViewerInteractionManager_$type]);
    return SeriesViewerInteractionManager;
}(Base));
export { SeriesViewerInteractionManager };
